=== include/CMakeLists.txt ===
add_subdirectory(orcus)
