=== src/test/CMakeLists.txt ===

add_library(orcus-test STATIC test_global.cpp mock_spreadsheet.cpp)
